import type {
  RecordEntry,
  RecordRef,
  AuthRecord,
  RecordSet,
  JsonData,
  FlistSet,
  PlistSet,
  SlistSet,
  RecordRefEns,
} from 'toolkit-data-structures';

//

interface Auth {
  get(): Promise<AuthRecord>;
  record(recordRef: RecordRef): Promise<AuthRecord>;
  token(authorization: string): Promise<AuthRecord>;
  activeState(record: RecordEntry): Promise<boolean>;
  createToken(record: RecordEntry): Promise<string>;
}

interface CacheDump {
  records: RecordSet;
  flists: FlistSet;
  plists: PlistSet;
  slists: SlistSet;
  removedRecords: RecordRefEns[] | null;
}

//

interface RecordDataInterface {
  [key: string]: any;
  uuid: string;
  createdAt: string;
}
type RecordData = RecordDataInterface | null;

interface RecordStoreBlueprint {
  repository: string;
  fields: RecordData;
}

interface RecordUpdateBlueprint {
  repository: string;
  uuid: string;
  createdAt: string;
  fields: JsonData;
}

//

export type { RecordData, RecordDataInterface, RecordStoreBlueprint, RecordUpdateBlueprint, Auth, CacheDump };
